#ifndef _IETQW_H_
#define _IETQW_H_

#include <string.h>
#include "vupshared.h"


#define ETQWWinMagic "455451570000000077696E2D78383600??????20????20????????00????3A????3A????00"
#define ETQWWinVerMagic "50 51 6A 0? 6A 01 68 ?? ?? 7? 00 68 ?? ?? 7? 00"

#define ETQWLinMagic "????3A????3A????00??????20????20????????006C696E75782D7838360025732025642E25642E25642E256420257320257320257320257300"
#define ETQWLinVerMagic "89 44 24 14 : {B8 ?? ?? ?? 00 ^ 31 C0} : 89 44 24 10 B8 ?? ?? ?? 00 89 44 24 0C [B8 ?? ?? ?? ?? : 89 44 24 08] \
                         [B8 ?? ?? ?? ?? : 89 44 24 04] : E8 ?? ?? E? FF : B8 ?? ?? ?? 08 : B? ?? ?? ?? 08 : A3 ?? ?? ?? 08"
#define ETQWLinBuildSubMagic "89 44 24 ?? A1 ?? ?? ?? ??"


/*
Here i'll define patterns to handle various etqw versions :D

*/

/* Those are patterns for UNiX builds of ETQW */
/*#define ETQW_NiX_netLAN_Src_1 "0F 84 ?? ?? 00 00 C7 47 ?? 01 00 00 00 8B 45 EC BF 20 00 00 00 89 7C 24 08"*/
#define ETQW_NiX_netLAN_Src_1 "{7? ?? ^ 0F ?? ?? ?? 00 00} : 8D ?5 0C : 89 ?? 24 : E8 ?? ?? ?? 00 : 84 C0 :0F {84 ^ 85} ?? ?? {FF FF ^ 00 00}"
//#define ETQW_NiX_netLAN_Dst_1 "66 89 C0 66 89 C0 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"
#define ETQW_NiX_netLAN_Dst_1_a "90 E9"
#define ETQW_NiX_netLAN_Dst_1_b "66 89 C0 66 89 C0"

/* #define ETQW_NiX_netLAN_Src_2 "74 3C 84 D2 75 38 A1 E0 ?8 6? 08 8D 55 0C 8B 00 8B 58 38 89 14 24 E8 ?A" */
#define ETQW_NiX_netLAN_Src_2 "74 ?? 84 D2 75 ?? A1 E0 ?? 6? 08"
#define ETQW_NiX_netLAN_Src_2_b "A1 ?? ?? ?? 08 : 8D 55 0C : 8B 00 : 8B 58 38 : 89 14 24 : E8 ?? ?? ?? 00 : 89 44 24 08 : A1 ?? ?? ?? 08 : BE ?? ?? ?? 08 :\
                                 89 74 24 04 : 89 04 24"
#define ETQW_NiX_netLAN_Dst_2   "EB ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"

#define ETQW_NiX_Connect_Src      "0F 84 ?? 01 00 00 83 F8 03 0F 84 ?? ?? 00 00 85 C0 0F 85 ?? 00 00 00 8? ??"
#define ETQW_NiX_Connect_Dst_LAN  "66 89 C0 66 89 C0 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"
#define ETQW_NiX_Connect_Dst_INET "?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? 90 E9 ?? ?? ?? ?? ?? ??"
/* End */

/* Those are patterns for Win32 builds of ETQW */
#define ETQW_WiN_netLAN_vPre12_Src_1 "74 ?? 8D 8C 24 ?? 80 00 00 51 E8 ?? ?? 01 00 83 C4 04 84 C0 74 ?? 89 ?? ?? E9 ?? 00 00 00"
#define ETQW_WiN_netLAN_vPre12_Dst_1 "?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? 8B C0 ?? ?? ?? ?? ?? ?? ??"

#define ETQW_WiN_netLAN_vPre12_Src_2 "74 ?? 84 C0 75 ?? 8B 15 ?? ?? ?? 00 8B ?A 8D 84 24 ?? 80 00 00 50 83 C? 34 E8 ?? ?? 01 00"
#define ETQW_Win_netLAN_vPre12_Dst_2 "EB ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"

#define ETQW_WiN_netLAN_v12_Src "0F 84 D1 00 00 00 8D 84 24 54 80 00 00 50 E8 67 ?? 01 00 83 C4 04 84 C0 0F 85 1C 01 00"
#define ETQW_Win_netLAN_v12_Dst "66 89 C0 66 89 C0 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? 90 E9 ?? ?? ??"

//#define ETQW_WiN_Connect_Src        "0F 84 8? 00 00 00 ?? ?? ?? ?? ?? ?? ?? ?? ?? 8? ?? 01 0? ?? ?? ?? ?? ?0 8B ?? 24"
#define ETQW_WiN_Connect_Src          "0F 84 8? 00 00 00 ?? ?? ?? ?? ?? ?? ?? ?? ?? 8? ?? 01 0? ?? ?? ?? ?? ?? 8? ?? ??"
#define ETQW_WiN_Connect_Dst_LAN    "?? ?? ?? ?? ?? ?? ?? ?? ?? B8 FF FF FF FF 90 E9 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"
#define ETQW_WiN_Connect_Dst_LANb   "?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? B8 01 00 00 00 90 E9 ?? ?? ?? ?? ?? ?? ?? ?? ??"
#define ETQW_WiN_Connect_Dst_Extra5 "BA 02 00 00 00"
#define ETQW_WiN_Connect_Dst_INET   "66 89 C0 66 89 C0 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"
/* End */

TBOOL IfETQWEngine(TSTREAMADDR_HDR const fileStream,const TVUP_OSType fileOS,char Version[200]);

void PatchETQWEngine(TSTREAMADDR_HDR const fileStream,const TVUP_OSType fileOS,TBOOL PromtUser,TBOOL ClientChecks,TBOOL *PatchingResult,char Version[200]);

















#endif
